//
//Mario's voice lines and the function to play them
//

function A_MarioVoiceEcho(mo, var1, var2)
	local target = mo.target
	if not target then return end
	if not target.valid or mo.threshold >= mo.reactiontime + TICRATE*2
		mo.state = S_NULL
		return
	end
	
	mo.threshold = $ + 1
	if mo.threshold == mo.reactiontime and mariovoice.value
		S_StartSoundAtVolume(mo, mo.lastlook, mo.cusval)
	end
end
states[freeslot("S_MARIO_VOICEECHO")] = {SPR_NULL, 0, 1, A_MarioVoiceEcho, 0, 0, S_MARIO_VOICEECHO}

//Random function for the voices (local only!)
local mariorandomseed = 3135128580
local MarioRandom = function(a,b)
	mariorandomseed = $*(max(gamemap+globallevelskynum+leveltime, 1)%128)
	if consoleplayer and consoleplayer.valid
	and consoleplayer.mo and consoleplayer.mo.valid
		mariorandomseed = $-(consoleplayer.mo.x+consoleplayer.mo.y+consoleplayer.mo.z)
	end
	mariorandomseed = $/2
	local dumb = ((mariorandomseed*36548569) >> 4) & (FRACUNIT-1)
	return ((dumb * (b-a+1)) >> FRACBITS) + a
end

//Let's freeslot!
local FreeslotVoices = function(...)
	for _, sound in ipairs({...})
		//Normal voice
		local id = _G["sfx_mr"..sound]
		if id == nil
			id = freeslot("sfx_mr"..sound)
		end
		sfxinfo[id].caption = "/"
		sfxinfo[id].flags = SF_TOTALLYSINGLE
		
		//We don't need the powerups voices in Persona, they only take up freeslots
		if srb2p then continue end
		
		//Metal voice
		id = _G["sfx_m2"..sound]
		if id == nil
			id = freeslot("sfx_m2"..sound)
		end
		sfxinfo[id].caption = "/"
		sfxinfo[id].flags = SF_TOTALLYSINGLE
		
		//Mini voice
		id = _G["sfx_m3"..sound]
		if id == nil
			id = freeslot("sfx_m3"..sound)
		end
		sfxinfo[id].caption = "/"
		sfxinfo[id].flags = SF_TOTALLYSINGLE
	end
end
FreeslotVoices("ahah", "ahow", "boig", "die1", "die2", "die3", "doh", "drwn",
"edg1", "edg2", "fall", "grua", /*"haha",*/ "heho", "helo", "hmm", "ho", "hoho",
"hol", /*"hoo",*/ "hot", "hray", "huah", "itsa", "lava", "lets", "mama", "muh",
"muu", /*"nice",*/ "oh", "ohho", "okie", "oof", "ow", "pull", "scrm", "shoo",
"stnk", "time", "uh", "uhn", "wah", "waha", "waho", "walf", "wawl", /*"wego",*/
"wehe", "weho", "wihe", "woah", "woch", "woho", "yah", "yaho", "yehe", "yeho",
"yhaw", "yipe", "you", "yul", "supr", "ohya")

//Define the voices...
local MarioVoices = {
	["jump"] = {
		"ho",
		"uhn",
		"wah",
		"wawl",
		"yah",
		"yul",
	},
	
	["double"] = {
		"hol",
		"hoho",
		"muu",
		"muh",
	},
	
	["triple"] = {
		"waha",
		"waho",
		"yaho",
		"yehe",
		"yipe",
	},
	
	["spin"] = {
		"heho",
		"wihe",
		"you",
		"shoo",
		"woho",
		"weho",
	},
	
	["spinjump"] = {
		"ahah",
		"boig",
		"hray",
		"wehe",
		"yhaw",
	},
	
	["dive"] = {
		"hoho",
		"wah",
		"yah",
	},
	
	["hop"] = "walf",
	["recovery"] = {
		"hol",
		"hol",
		"hol",
		"muu",
		"muu",
		"muh",
	},
	
	["long"] = {
		"yaho",
		"yaho",
		"yaho",
		"yaho",
		"yeho",
	},
	
	["groundpound"] = "hmm",
	
	//["attack"] = "hoo",
	
	["bonk"] = "doh",
	["butt"] = "oof",
	
	["pain"] = {
		"grua",
		"oh",
		"ohho",
		"ow",
		"huah",
		"woch",
	},
	
	["fall"] = "fall",
	
	["lava"] = {
		"ahow",
		"fall",
		"lava",
		"scrm",
		"hot",
	},
	
	["die"] = {
		"die1",
		"die2",
		"die3",
		"mama",
	},
	
	["drown"] = "drwn",
	
	["edge"] = {
		"edg1",
		"edg2",
	},
	
	["grab"] = "woah",
	["bump"] = "uh",
	["pull"] = "pull",
	
	["hello"] = {
		"helo",
		"itsa",
		"lets",
		"okie",
		"time",
	},
	
	/*["win"] = {
		"nice",
		"wego",
	},*/
	
	["super"] = "supr",
	["star"] = "ohya",
	
	["stinky"] = "stnk",
}

//Finally the function that plays it!
rawset(_G, "MarioPlayVoice", function(player, voice, forcenil)
	//Your mouth is closed!
	if (player.powers[pw_shield] == SH_BALLOON and not player.mariopain)
	or player.powers[pw_shield] == SH_SUPERBALL return end
	
	if player.marioechoes and #player.marioechoes
		for i, echo in pairs(player.marioechoes) do
			if echo and echo.valid and echo.type == MT_OVERLAY
				echo.threshold = max($, TICRATE*2)
			end
		end
	end
	player.marioechoes = {}
	
	local mo = player.followmobj
	if mo and mo.valid
		S_StopSound(mo)
	elseif not forcenil
		mo = player.mo
		if not (mo and mo.valid) then return end
	end
	if forcenil then mo = nil end
	
	local table = MarioVoices[voice]
	local sound
	if type(table) == "string"
		sound = table
	
	elseif type(table) == "table"
		sound = table[MarioRandom(1, #table)]
		
	else
		sound = voice
	end
	
	//Metal, mini, or normal voice?
	if player.powers[pw_shield] == SH_GOLDFLOWER
	or player.powers[pw_shield] == SH_METAL
		sound = _G["sfx_m2"..$]
	elseif player.mariosize < 0
		sound = _G["sfx_m3"..$]
	else
		sound = _G["sfx_mr"..$]
	end
	if sound == nil then return end
	
	//Only actually play the sound when enabled via command
	if mariovoice.value
		S_StartSound(mo, sound)
	end
	
	//Set up the Ecco the Dolphin objects
	//We can't have this be local only...
	if not forcenil and mo and player.powers[pw_invulnerability]
		for i = 1, 2
			local echo = P_SpawnMobjFromMobj(mo, 0,0,0, MT_OVERLAY)
			echo.target = mo
			echo.tracer = mo
			echo.cusval = 256 - 96*i
			echo.reactiontime = TICRATE/3*i
			echo.lastlook = sound
			echo.state = S_MARIO_VOICEECHO
			
			player.marioechoes[i] = echo
		end
	end
end)